package src.hw7S10;

import java.io.*;

public class TruckTest {
	public static void main(String[] args) {
		run();
	}

	public static void run()
	{
		int [] weights = loadData("src/hw7S09new/itemweights.txt");
		int total_capacity = 0;
		for (int i=0, e=weights.length; i<e; ++i)
			total_capacity += weights[i];
		System.out.println("Total width of all input cases: " + total_capacity);
		
		if ( false ) { // a small test
			int w = 48;
			System.out.println("Solving capacity=" + w + ", theoretical lower bound is " + (double)total_capacity/w);
			PackingSolver ps = new PackingSolver(w, weights);
			ps.solve();
		}
		else
		{
			int width_start = 48, width_end = 61; 
			for( int w=width_start; w<width_end; ++w)
			{
				System.out.println("Solving capacity=" + w + ", theoretical lower bound is " + (double)total_capacity/w);
				PackingSolver ps = new PackingSolver(w, weights);
				ps.solve();
			}
		}
	}
	
	
	public static int[] loadData(String filename)
	{
		try {
			FileReader fin = new FileReader(filename);
			BufferedReader in = new BufferedReader(fin);
			int n= Integer.parseInt(in.readLine());
			int[] cases= new int[n];
			for (int i=0; i < n; i++) {
				String str = in.readLine();
				cases[i] = Integer.parseInt(str);
			}
			in.close();
			return cases;
		} catch(IOException e) {
			System.out.println(e);
		}
		return null;
	}
	
}
