package src.hw7S10;

import java.util.*;

public class Pattern {
	ArrayList<Pair> pairs;
	int allocated; // the number of pallets generated in this pattern
	
	public Pattern(ArrayList<Pair> p, int allc)
	{
		pairs = p;
		allocated = allc;
	}
	
	public String toString()
	{
		String s = "[";
		for(Pair p: pairs)
			s += p.first + "x" + p.second + " ";
		s += "] x " + allocated;
		return s;
	}
	
	// return the width of the pattern
	public int width()
	{
		int sum = 0;
		for ( Pair p : pairs)
			sum += p.first * p.second;
		return sum;
	}
	
	// verify if the pattern matches the width exactly
	public boolean checksum(int width)
	{
		return width() == width;
	}
}
